#include "unp.h"
#include <cerrno>
#include <cstddef>
#include <cstdio>
#include <iostream>
#include <unistd.h>

static int read_cnt;
static char *read_ptr;
static char read_buff[MAXLINE];

static ssize_t 
my_read(int fd, char *ptr)
{
    if (read_cnt <= 0) {
    again:
        if ( (read_cnt = read(fd, read_buff, sizeof(read_buff))) < 0) {
            if (errno == EINTR)
                goto again;
            else if (read_cnt == 0)
                return 0;
            read_ptr = read_buff;
        } 
    }

    read_cnt--;
    *ptr = *read_ptr++;
    return 1;
}

ssize_t
readline(int fd, void *vptr, size_t maxlen)
{
    ssize_t n, returnvalue;
    char c, *ptr;

    ptr = (char *) vptr;
    for (n = 1; n < maxlen; n++) {
        if ( (returnvalue = my_read(fd, &c)) == 1) {
            *ptr++ = c;
            if (c == '\n')
                break;
            else if (returnvalue == 0) {
                *ptr = 0;
                return (n - 1); // EOF, n - 1 bytes were read
            } else {
                return -1;
            }
        }
    }
    *ptr = 0;
    return n;
}

ssize_t
readlinebuf(void **vptrptr)
{
    if (read_cnt)
        *vptrptr = read_ptr;
    return read_cnt;
}

/*
* 从描述符中读取文本行
*/
ssize_t
Readline(int fd, void *ptr, size_t maxlen)
{
    ssize_t n;
    if ( (n = readline(fd, ptr, maxlen)) < 0)
        std::cerr << "readline error" << std::endl;

    return n;
}