#include <cstring>
#include <iostream>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>

// 将socket随机绑定到一个端口
// 返回端口的值
int 
sock_bind_wild(int sockfd, int family)
{
    socklen_t len;
    switch (family) {
    case AF_INET: {
            struct sockaddr_in sin;

            bzero(&sin, sizeof(sin));
            sin.sin_family = AF_INET;
            sin.sin_addr.s_addr = htonl(INADDR_ANY);
            sin.sin_port = htons(0);    // 随机端口

            if (bind(sockfd, (struct sockaddr *) &sin, sizeof(sin)) < 0)
                return -1;
            // 更新sin想内核获取具体的sockaddr_in信息
            len = sizeof(sin);
            if (getsockname(sockfd, (struct sockaddr *) &sin, &len) < 0)
                return -1;

            return sin.sin_port;
        }
    case AF_INET6: {
            struct sockaddr_in6 sin6;

            bzero(&sin6, sizeof(sin6));
            sin6.sin6_family = AF_INET6;
            sin6.sin6_addr = IN6ADDR_ANY_INIT;
            sin6.sin6_port = htons(0);    // 随机端口

            if (bind(sockfd, (struct sockaddr *) &sin6, sizeof(sin6)) < 0)
                return -1;
            // 更新sin想内核获取具体的sockaddr_in信息
            len = sizeof(sin6);
            if (getsockname(sockfd, (struct sockaddr *) &sin6, &len) < 0)
                return -1;

            return sin6.sin6_port;
        }
    }
    // end switch
    return -1;
}

int 
Sock_bind_wild(int sockfd, int family)
{
    int port;

    if ( (port = sock_bind_wild(sockfd, family)) < 0)
        std::cerr << "sock_bind_wild error" << std::endl;

    return port;
}