
#include <cstring>
#include <netinet/in.h>
#include <sys/socket.h>

/*
*   判断两个地址是否相等，0代表相等
*/
int 
sock_cmp_addr(const struct sockaddr *sa1, const struct sockaddr *sa2, socklen_t salen)
{
    if (sa1->sa_family != sa2->sa_family)
        return -1;

    switch (sa1->sa_family) {
    case AF_INET: {
            return (memcmp( &((struct sockaddr_in *)sa1)->sin_addr, &((struct sockaddr_in *)sa2)->sin_addr, sizeof(in_addr)));
        }
    case AF_INET6: {
            return (memcmp( &((struct sockaddr_in6 *)sa1)->sin6_addr, &((struct sockaddr_in6 *)sa2)->sin6_addr, sizeof(in6_addr)));
        }
    }
    // end switch
    return -1;
}