#include <netinet/in.h>
#include <sys/socket.h>

/*
*   获取sockaddr中的port，注意返回的是网络字节序
*/
int 
sock_get_port(const struct sockaddr *sa, socklen_t salen)
{
    switch (sa->sa_family) {
    case AF_INET: {
            struct sockaddr_in *sin = (struct sockaddr_in *) sa;
            // sin_port is 16bit size
            return(sin->sin_port);
        }
    case AF_INET6: {
            struct sockaddr_in6 *sin = (struct sockaddr_in6 *) sa;
            // sin_port is 16bit size
            return(sin->sin6_port);
        }
    }
    // end switch

    return -1;
}