#include <cstddef>
#include <iostream>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>


char *
sock_ntop_host(const sockaddr *sa, socklen_t salen)
{
    static char str[128];   // Unix domain is largest

    switch (sa->sa_family) {
    case AF_INET: {
            struct sockaddr_in *sin = (struct sockaddr_in *) sa;
            if (inet_ntop(AF_INET, &sin->sin_addr, str, sizeof(str)) == NULL)
                return NULL;
            return str;
        }
    case AF_INET6: {
        struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *) sa;
        if (inet_ntop(AF_INET, &sin6->sin6_addr, str, sizeof(str)) == NULL)
            return NULL;
        return str;
    }
    }
    // end switch
    return NULL;
}

/*
*   将地址的网络字节序转换为字符串
*/
char *
Sock_ntop_host(const struct sockaddr *sa, socklen_t salen)
{
    char *ptr;

    if( (ptr = sock_ntop_host(sa, salen)) == NULL)
        std::cerr << "sock_ntop_host" << std::endl;
    return ptr;
}