#include <arpa/inet.h>
#include <cstring>
#include <netinet/in.h>
#include <sys/socket.h>


/*
*   设置sockaddr中的sin_addr和sin6_addr，addr参数是网络字节序
*/
void
sock_set_addr(struct sockaddr *sa, socklen_t salen, const void *addr)
{
    switch (sa->sa_family) {
    case AF_INET: {
            struct sockaddr_in *sin = (struct sockaddr_in *) sa;

            memcpy(&sin->sin_addr, addr, sizeof(in_addr));
            return;
        }
    case AF_INET6: {
        struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *) sa;

        memcpy(&sin6->sin6_addr, addr, sizeof(in_addr));
        return;
    }
    }
    // end switch
}