#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include "unp.h"

/*
*   将sa中的address设置为ANY，任意一个地址
*/

void 
sock_set_wild(struct sockaddr *sa, socklen_t salen)
{
    const void *wildptr;

    switch (sa->sa_family) {
    case AF_INET: {
            static struct in_addr  in4addr_any;

            in4addr_any.s_addr = htonl(INADDR_ANY);
            wildptr = &in4addr_any;
            break;
        }
    case AF_INET6: {
            wildptr = &in6addr_any;
            break;
        }
    default:
            return;
    }
    // end switch
    sock_set_addr(sa, salen, wildptr);
    return;
}