#pragma once
#include <arpa/inet.h>

#define MAXLINE 4096

// 将socket随机绑定到一个端口
// 返回端口的值
int 
sock_bind_wild(int sockfd, int family);

/*
*   判断两个地址是否相等，0代表相等
*/
int 
sock_cmp_addr(const struct sockaddr *sa1, const struct sockaddr *sa2, socklen_t salen);

/*
*   获取sockaddr中的port，注意返回的是网络字节序
*/
int 
sock_get_port(const struct sockaddr *sa, socklen_t salen);

/*
*   将地址的网络字节序转换为字符串
*/
char *
Sock_ntop_host(const struct sockaddr *sa, socklen_t salen);

// 数字类型的sockaddr（地址，端口）转换成字符串类型的sockaddr
// 返回字符串
char *
Sock_ntop(const struct sockaddr *sa, socklen_t salen);

/*
*   设置sockaddr中的sin_addr和sin6_addr，addr参数是网络字节序
*/
void
sock_set_addr(struct sockaddr *sa, socklen_t salen, const void *addr);

/*
*   设置sockaddr中的port，port参数是网络字节序
*/
void
sock_set_port(struct sockaddr *sa, socklen_t salen, int port);

/*
* 从描述符中读取文本行
*/
ssize_t
Readline(int fd, void *ptr, size_t maxlen);

/*
*   从文本描述符中写入n个字节
*/
void
Writen(int fd, void *ptr, size_t nbytes);

/*
*   从文本描述符中读取n个字节
*/
ssize_t
Readn(int fd, void *ptr, size_t nbytes);