#include <cerrno>
#include <cstddef>
#include <cstdio>
#include <iostream>
#include <unistd.h>

ssize_t 
writen(int fd, const void *vptr, size_t n)
{
    size_t nleft;
    ssize_t nwritten;
    const char *ptr;

    ptr = (const char *) vptr;
    nleft = n;
    while (nleft > 0) {
        if ( (nwritten = write(fd, ptr, nleft)) <= 0) {
            if (nwritten < 0 && errno == EINTR)
                nwritten = 0;   // and call write() again
            else 
                return -1;
        }

        nleft -= nwritten;
        ptr += nwritten;
    }

    return n;
}

/*
*   从文本描述符中写入n个字节
*/
void
Writen(int fd, void *ptr, size_t nbytes)
{
    if (writen(fd, ptr, nbytes) != nbytes)
        std::cerr << "writen error" << std::endl;
}